--main.lua
--the majority of stuff happens here.
--"C:\Program Files\LOVE\love.exe" "$(CURRENT_DIRECTORY)"
--Can only run scripts in same dir as main.lua, do don't run anything in lib or script


debugStrings = {}



function printDebug()
	local s = ""
	for i,val in ipairs(debugStrings) do s = s..val.."\n" end
	return s
end

function love.load()
	--Setup Libraries; The basic elements the game requires
	Object = require "lib/classic"
	Lume = require "lib/lume"
	Basic = require "lib/basic"
	require "lib/rpg"
	--Setup Scripts; What the game is made of
	
	--Setup Database; Setups all the Database
	
	--First Time Setup
	
	--Animation Testing
	local earthSprite = Sprite("imgs/_ph/earth2.png",64,64)
	--Entity Testing
	
	--The Player
	local plant = Animation("Plant",earthSprite,{15,15,16,16,16,16,17,18,19,20,0})
	plant:setSpeed(10.0)
	plant:setOrigin(16,16)
	player = Actor(0,0,0,100)
	player:setImg(plant)
	player:setCollision(32,32,100)
	player:setDraw(true,true)
	--Test Collider
	local windowWidth,windowHeight = love.graphics.getDimensions()
	for i=1,3 do
		local plant = Animation("Plant",earthSprite,{1,2,3,4,5,6,7,8,9,10,11,12,13,14,0})
		plant:setSpeed(8.0)
		plant:setOrigin(16,16)
		plant:randomIndex()
		local testActor = Actor(love.math.random(0,windowWidth/2),love.math.random(0,windowHeight/2),0,0)
		testActor:setImg(plant)
		testActor:setCollision(32,32,10)
		testActor:setDraw(true,true)
	end
	
	--Camera Testing
	mainCamera = Camera(0.45,0.45)
	mainCamera.pixelPerfect = true
	--Sound Testing
	quakeSFX = SoundObj("quake","audio/_ph/Darkness3.ogg",true)

end

function love.keypressed(key)
	if key == "space" then 
	--	mainCamera:setScreenShake(1,50) 
	--	quakeSFX:play()
	end
end

function love.mousepressed(x,y,button)

end

function love.update(dt)
	--Input
	if love.keyboard.isDown("left") then player.dx = -250
	elseif love.keyboard.isDown("right") then player.dx = 250
	else player.dx = 0
	end
	if love.keyboard.isDown("up") then player.dy = -250
	elseif love.keyboard.isDown("down") then player.dy = 250
	else player.dy = 0
	end
	--Update
	mainCamera:process(dt)
	Basic.process(dt)
	--Collisions
	Basic.collisions(dt,100)
	--Debug
	debugStrings[1] = "FPS:"..tostring(love.timer.getFPS())
end

function love.draw()
	love.graphics.push()
	mainCamera:draw(player.x,player.y)
	--Batch Drawing
	--Drawing
	Basic.draw()
	--HUD
	love.graphics.pop()
	love.graphics.print(printDebug(),0,0)
end